// Import vue component
import Vue from 'vue'
import Checkout from './checkout.vue'

// Declare install function executed by Vue.use()
let installed = false
export function install(vue: typeof Vue) {
  if (installed) return
  installed = true
  Vue.component('PrimerCheckout', Checkout)
}

// Create module definition for Vue.use()
const plugin = {
  install
}

// Auto-install when vue is found (eg. in browser via <script> tag)
let GlobalVue: typeof Vue | null = null
if (typeof window !== 'undefined') {
  GlobalVue = ((window as unknown) as {vue: typeof Vue}).vue
} else if (typeof global !== 'undefined') {
  GlobalVue = ((global as unknown) as {vue: typeof Vue}).vue
}
if (GlobalVue) {
  GlobalVue.use(plugin)
}

// To allow use as module (npm/webpack/etc.) export component
export const PrimerCheckout = Checkout
